/* Boitier de commande de déshmidificateur par B.LECLERC
 *  Dans un souci d'economie d'energie, je ne laisse pas 
 *  le déshumidificateur fonctionner en permannence
 * Une fonction assure la marche suivant une plage horaire (a cause du bruit)
 * et suivant la température, car les cellules ne fonctionnent pas en dessous de 15°C
 * et enclenchement suivant un taux d'humidité défini (ici 55%)*/
 
#include <Adafruit_SSD1306.h> // Utilisation de la Library Gestion Afficheur
#define OLED_RESET 4 // Utilisation de la Library Start Afficheur
Adafruit_SSD1306 display(OLED_RESET);  //définition de la séquence d'affichage

#include "Adafruit_SHT31.h"  // Utilisation de la Library Gestion de la sonde
Adafruit_SHT31 sht31 = Adafruit_SHT31(); //définition de la séquence de sonde

#include <DS3231_Simple.h> // Utilisation de la Library Gestion de l'horloge RTC
DS3231_Simple Clock; //  Séquence Horloge en temps réel

int Cde = 4;  //Déclaration de la commande du relais de marche en D4


void setup()
{
if (! sht31.begin(0x44)) // Controle de la présence de la sonde à le bonne adresse
  {
    while (1) delay(1);  // Et, si oui, on boucle tant qu'elle est vue 
}

pinMode(Cde, OUTPUT); //Mise en sortie de la commande de relais

display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  // Initialisation de l'afficheur et son adresse I2C 
Clock.begin(); // Lancement de la fonction horloge

}


void loop()
{

DateTime MyDateAndTime; //Dialogue avec RTC

float t = sht31.readTemperature(); //Lance la séquence de lecture de la température
float h = sht31.readHumidity(); //Idem pour l'humidité ambiante
MyDateAndTime = Clock.read(); //Lance la séquence de lecture de la RTC
int c = (MyDateAndTime.Hour); // Attribut une variable aux heures de fonctionnement


display.display();  // initialisation d'une séquence d'affichage 
display.clearDisplay(); // Effacement des écrits précédents 
display.setTextSize(1);  // Choix de la taille des caractères 
display.setTextColor(WHITE); // Choix de la couleur des caractères 
display.setCursor(1,0); // Position curseur 
display.println("Heure: ");  
display.setCursor(50,0);  // Position curseur
display.println(MyDateAndTime.Hour); //affichage des Heures
display.setCursor(70,0);  // Position curseur
display.println(MyDateAndTime.Minute); //affichage des Minutes
display.setCursor(90,0);  // Position curseur
display.println(MyDateAndTime.Second); //affichage des Secondes
display.setCursor(1,11);  // Position curseur
display.println("Temperature:");
display.setCursor(70,11);  // Position curseur
display.println(t,1); //affichage dela température
display.setCursor(90,11);  // Position curseur
display.println(" degC");
display.setCursor(1,21);  // Position curseur
display.println("Humidite: ");
display.setCursor(70,21);  // Position curseur
display.println(h,1);  //affichage de l'humidité
display.setCursor(90,21);  // Position curseur
display.println(" %");

if (((h)> (55)) and ((t)> (15)) and ((c)>(8)) and ((c)<(19))) { //Si l'humidité est supérieur à 55% 
  // et que la température est plus que 15°c et que l'on est dans la plage horaire
    digitalWrite(Cde, HIGH);  // on active le déshumidificateur

}else{
    digitalWrite(Cde, LOW);  // Sinon on désactive le déshumidificateur
}
delay(5000); //Temporisation de 5 secondes avant nouvelle lercture 

}
